#2569 closed defect (fixed)

m68k/mcf5329: linker script update (add KEEP() sections)

Reported by: Joel Sherrill Owned by: Joel Sherrill
Priority: normal Milestone: Indefinite
Component: bsps Version: 5
Severity: normal Keywords: function sections, KEEP
Cc: Blocked By:
Blocking:

Description

This BSP's linker script does not include KEEP() directives and thus cannot have per-function and per-data element section support enabled.

The preferred solution is to convert the BSP to use a shared base linker script. The acceptable solution is to add the proper KEEP directives to the existing linker script(s).

Shared linker scripts for the arm, m68k, and sparc have the proper KEEP sections and can serve as examples.

Change History (6)

comment:1 Changed on Feb 6, 2016 at 3:53:46 PM by Joel Sherrill <joel@…>

In ea791d52bd787737cf42bc216054ad4f9b0a8f0b/rtems:

m68k/.../mcf5329.cfg: Disable per function sections

updates #2569.

comment:2 Changed on Feb 15, 2017 at 1:49:47 PM by Sebastian Huber

Owner: set to Joel Sherrill
Status: newassigned

comment:3 Changed on May 11, 2017 at 7:31:02 AM by Sebastian Huber

Milestone: 4.124.12.0

comment:4 Changed on Aug 24, 2017 at 5:59:58 AM by Sebastian Huber

Milestone: 4.12.0Indefinite

comment:5 Changed on Sep 14, 2018 at 6:59:32 PM by Joel Sherrill

Keywords: function sections KEEP added

comment:6 Changed on Nov 28, 2018 at 8:50:56 PM by Shashvat Jain <shashvatjain2002@…>

Resolution: fixed
Status: assignedclosed

In cc119eb/rtems:

m68k/mcf5329:Add per-section compilation and linking support (GCI 2018)

The size of the sample executables without this option were:

text data bss dec hex filename

87654 1152 11968 100774 189a6 base_sp.exe

203318 2112 14896 220326 35ca6 capture.exe
257014 2912 12960 272886 429f6 cdtest.exe
865750 21888 19648 907286 dd816 cxx_iostream.exe
569078 4640 24352 598070 92036 fileio.exe
121094 1520 12048 134662 20e06 hello.exe

70614 1024 8768 80406 13a16 minimum.exe

110806 1632 12080 124518 1e666 nsecs.exe
196326 1920 12688 210934 337f6 paranoia.exe

90406 1184 12000 103590 194a6 ticker.exe
89958 1136 15808 106902 1a196 unlimited.exe

The size of the sample executables with this option were:

text data bss dec hex filename

83270 1152 11888 96310 17836 base_sp.exe

189974 2112 14864 206950 32866 capture.exe
188982 2144 12928 204054 31d16 cdtest.exe
188662 2240 13072 203974 31cc6 cxx_iostream.exe
556822 4624 24048 585494 8ef16 fileio.exe
112422 1520 12016 125958 1ec06 hello.exe

66086 1008 8688 75782 12806 minimum.exe

104982 1632 11984 118598 1cf46 nsecs.exe
187958 1904 12656 202518 31716 paranoia.exe

85766 1184 11920 98870 18236 ticker.exe
88406 1120 15776 105302 19b56 unlimited.exe

Closes #2569

Note: See TracTickets for help on using tickets.